
#include <ddraw.h>
#include "../vjeffect.h"
#include "../gfxpixel.h"


//--------------------------------------------------------------------------
// NX`
//--------------------------------------------------------------------------
// NX͊{I [Copy/Mix/Modify/Generate]+[ŗL̖O] œꂵĂD
//  Copy : In x 1  , Out x 1 (Rs[)
//  Mix  : In x 2+ , Out x 1 (Qȏ̃\[XɃRs[)
//  Modify :       , Out x 1 (o͐ω)
//  Generate :     , Out x 1 (摜𐶐)

// Release() : ~CVJCopy()OQƂȂ,ɑ̂Lq (ėǂł)
// MessageProc() : VJM_??? bZ[W󂯎֐łDfBXpb`ĂD

// mNRs[
class CVJCopyDiff : public CVJEffecter
{
public:
	CVJCopyDiff();
	~CVJCopyDiff();

	void Release();
	int MessageProc(int,DWORD,DWORD);
	VJOBJINFO* GetInfo();

	int Effect(VJEFFECTINFO*);
	int Effect32(VJEFFECTINFO*);

public:
	int colorMode;
};

//--------------------------------------------------------------------------
// VJEffecterNX`
//--------------------------------------------------------------------------
// {̂ɓnNX̏ڍׂłDK`ĂD

CVJEffecter* GetVJCopyDiff(){return new CVJCopyDiff();}

VJOBJINFO VJOBJCopyDiff=
{
	sizeof(VJOBJINFO),
	VJ_EFFECT_COPY,	// K؂Ȍ^`
	"CopyDiff",		// O`
	1,					// Num of Out Channel
	1,					// Num of In  Channel
	0,					// Num of Param
	NULL,				// Data of Param
	&GetVJCopyDiff
};

VJOBJINFO* CVJCopyDiff::GetInfo(){return &VJOBJCopyDiff;}




//--------------------------------------------------------------------------
// GtFNg֐`
//--------------------------------------------------------------------------

template <class VIN,class VOUT>
static void EffectCopyDiff(VJEFFECTINFO *pInfo,VIN *pvi,DDSURFACEDESC *pdeski,VOUT *pvo,DDSURFACEDESC *pdesko)
{

	RECT rect;
	rect.bottom= pdesko->dwHeight > pdeski->dwHeight ? pdeski->dwHeight : pdesko->dwHeight ;
	rect.right = pdesko->dwWidth  > pdeski->dwWidth  ? pdeski->dwWidth  : pdesko->dwWidth ;

	VIN  *pVi=pvi  ,*poVi=pvi;
	VOUT *pVo=pvo  ,*poVo=pvo;

	int x,y;
	int i;
	int r,g,b,t;

	for(y=0;y<rect.bottom;y++)
	{
		for(x=0;x<rect.right;x++)
		{
			r = pVi[x].GetR() - pVi[x+1].GetR() ;
			g = pVi[x].GetG() - pVi[x+1].GetG() ;
			b = pVi[x].GetB() - pVi[x+1].GetB() ;

			r+= pVi[x].GetR() - poVi[x].GetR();
			g+= pVi[x].GetG() - poVi[x].GetG();
			b+= pVi[x].GetB() - poVi[x].GetB();

			r=r<0?-r:r;
			g=g<0?-g:g;
			b=b<0?-b:b;

			pVo[x].SetRGB(r,g,b);
		}
		poVi=pVi;
		poVo=pVo;
		pVi= (VIN *) ((BYTE*)pVi+pdeski->lPitch);
		pVo= (VOUT*) ((BYTE*)pVo+pdesko->lPitch);
	}
}

//--------------------------------------------------------------------------
// o֐`
//--------------------------------------------------------------------------


CVJCopyDiff::CVJCopyDiff()
{
}

CVJCopyDiff::~CVJCopyDiff()
{
}

void CVJCopyDiff::Release()
{

}

int CVJCopyDiff::MessageProc(int msg,DWORD wParam,DWORD lParam)
{

	if(msg==VJM_EFFECT)
		return Effect( (VJEFFECTINFO*)wParam );
}

int CVJCopyDiff::Effect(VJEFFECTINFO *pInfo)
{
	// arg check
	if(pInfo->cbSize<sizeof(VJEFFECTINFO)) return -1;

	if(pInfo->nInChannel!=1 || pInfo->nOutChannel!=1 || pInfo->nParam!=2) return -1;

	IDirectDrawSurface *pDDSi,*pDDSo;
	pDDSo=(IDirectDrawSurface*)pInfo->pOutChannel[0];
	pDDSi=(IDirectDrawSurface*)pInfo->pInChannel [0];

	// Lock DDSurface
	HRESULT hr;

	DDSURFACEDESC deski,desko;
	desko.dwSize=deski.dwSize=sizeof(DDSURFACEDESC);
	if(pDDSo==pDDSi)
	{
		hr=pDDSi->Lock(NULL,&deski,DDLOCK_WAIT,NULL);
		if(FAILED(hr)) return -1;
		desko=deski;
		pDDSi->Unlock(NULL);
	}else{
		hr=pDDSi->Lock(NULL,&deski,DDLOCK_READONLY | DDLOCK_WAIT,NULL);
		if(FAILED(hr)) return -1;
		pDDSi->Unlock(NULL);
		hr=pDDSo->Lock(NULL,&desko,DDLOCK_WRITEONLY | DDLOCK_WAIT,NULL);
		if(FAILED(hr)){ pDDSi->Unlock(NULL);return -1; }
	}

	if(deski.ddpfPixelFormat.dwRGBBitCount==32)
	{
		EffectCopyDiff( pInfo, (V32*)deski.lpSurface,&deski,(V32*)desko.lpSurface,&desko );
	}else if(deski.ddpfPixelFormat.dwRGBBitCount==24)
	{
		EffectCopyDiff( pInfo, (V24*)deski.lpSurface,&deski,(V24*)desko.lpSurface,&desko );
	}else if(deski.ddpfPixelFormat.dwRGBBitCount==16)
	{
		EffectCopyDiff( pInfo, (V16g*)deski.lpSurface,&deski,(V16g*)desko.lpSurface,&desko );
	}

	pDDSo->Unlock(NULL);
}

